package com.tzld.piaoquan.ad.engine.commons.enums;

public enum VlogAdFeatureGroup {
    MID,
    MACHINEINFO_BRAND,
    MACHINEINFO_MODEL,
    MACHINEINFO_PLATFORM,
    MACHINEINFO_SDKVERSION,
    MACHINEINFO_SYSTEM,
    MACHINEINFO_WECHATVERSION,


    DAY,
    WEEK,
    HOUR,
    REGION,
    CITY,

    // AD info
    ADID,
    CREATIVE,
    ADVERID,
    CAMPAIGIN,




    USER_1DAY_EXP,
    USER_1DAY_CLICK,
    USER_1DAY_CTR,
    USER_1DAY_CVR,

    USER_3DAY_EXP,
    USER_3DAY_CLICK,
    USER_3DAY_CTR,
    USER_3DAY_CVR,

    USER_7DAY_EXP,
    USER_7DAY_CLICK,
    USER_7DAY_CTR,
    USER_7DAY_CVR,

    USER_3MONTH_EXP,
    USER_3MONTH_CLICK,
    USER_3MONTH_CTR,
    USER_3MONTH_CVR,


    ITEM_1DAY_EXP,
    ITEM_1DAY_CLICK,
    ITEM_1DAY_CTR,
    ITEM_1DAY_CVR,

    ITEM_3DAY_EXP,
    ITEM_3DAY_CLICK,
    ITEM_3DAY_CTR,
    ITEM_3DAY_CVR,

    ITEM_7DAY_EXP,
    ITEM_7DAY_CLICK,
    ITEM_7DAY_CTR,
    ITEM_7DAY_CVR,

    ITEM_3MONTH_EXP,
    ITEM_3MONTH_CLICK,
    ITEM_3MONTH_CTR,
    ITEM_3MONTH_CVR,


    ;


    private final byte[] idBytes;
    private final byte[] nameBytes;

    VlogAdFeatureGroup() {
        this.nameBytes = name().toLowerCase().getBytes();
        this.idBytes = String.valueOf(ordinal()).getBytes();
    }

    public final int getId() {
        return ordinal();
    }

    public final String getGroupName() {
        return name().toLowerCase();
    }

    public final byte[] getGroupNameBytes() {
        return getGroupName().getBytes();
    }

    public final byte[] getIdBytes() {
        return idBytes;
    }

}
